// Fig. 10.17: BasePlusCommissionEmployee5.cs
// BasePlusCommissionEmployee5 class declaration.
using System;

public class BasePlusCommissionEmployee5 : CommissionEmployee4
{
   private decimal baseSalary; // base salary per week

   // six-parameter derived class constructor
   // with call to base class CommissionEmployee4 constructor
   public BasePlusCommissionEmployee5( string first, string last,
      string ssn, decimal sales, decimal rate, decimal salary )
      : base( first, last, ssn, sales, rate )
   {
      BaseSalary = salary; // validate base salary via property

      Console.WriteLine( 
         "\nBasePlusCommissionEmployee5 constructor:\n" + this );
   } // end six-parameter BasePlusCommissionEmployee5 constructor

   // property that gets and sets 
   // base-salaried commission employee's base salary
   public decimal BaseSalary
   {
      get
      {
         return baseSalary;
      } // end get
      set
      {
         baseSalary = ( value < 0 ) ? 0 : value;
      } // end set
   } // end property BaseSalary

   // calculate earnings
   public override decimal Earnings()
   {
      return BaseSalary + base.Earnings();
   } // end method Earnings

   // return string representation of BasePlusCommissionEmployee5
   public override string ToString()
   {
      return string.Format( "{0} {1}\n{2}: {3:C}",
         "base-salaried", base.ToString(), "base salary", BaseSalary );
   } // end method ToString
} // end class BasePlusCommissionEmployee5


/**************************************************************************
 * (C) Copyright 1992-2006 by Deitel & Associates, Inc. and               *
 * Pearson Education, Inc. All Rights Reserved.                           *
 *                                                                        *
 * DISCLAIMER: The authors and publisher of this book have used their     *
 * best efforts in preparing the book. These efforts include the          *
 * development, research, and testing of the theories and programs        *
 * to determine their effectiveness. The authors and publisher make       *
 * no warranty of any kind, expressed or implied, with regard to these    *
 * programs or to the documentation contained in these books. The authors *
 * and publisher shall not be liable in any event for incidental or       *
 * consequential damages in connection with, or arising out of, the       *
 * furnishing, performance, or use of these programs.                     *
 *************************************************************************/
