// Fig. 15.14: GUIThreads.cs
// Demonstrates using threads in a GUI
using System;
using System.Windows.Forms;
using System.Threading;

public partial class GUIThreadsForm : Form
{
   public GUIThreadsForm()
   {
      InitializeComponent();
   } // end constructor

   private RandomLetters letter1; // first RandomLetters object
   private RandomLetters letter2; // second RandomLetters object
   private RandomLetters letter3; // third RandomLetters object

   private void GUIThreadsForm_Load( object sender, EventArgs e )
   {
      // create first thread
      letter1 = new RandomLetters( thread1Label );
      Thread firstThread = new Thread( 
         new ThreadStart( letter1.GenerateRandomCharacters ) );
      firstThread.Name = "Thread 1";
      firstThread.Start();

      // create second thread
      letter2 = new RandomLetters( thread2Label );
      Thread secondThread = new Thread( 
         new ThreadStart( letter2.GenerateRandomCharacters ) );
      secondThread.Name = "Thread 2";
      secondThread.Start();

      // create third thread
      letter3 = new RandomLetters( thread3Label );
      Thread thirdThread = new Thread( 
         new ThreadStart( letter3.GenerateRandomCharacters ) );
      thirdThread.Name = "Thread 3";
      thirdThread.Start();
   } // end method GUIThreadsForm_Load

   // close all threads associated with this application
   private void GUIThreadsForm_FormClosing( object sender, 
      FormClosingEventArgs e )
   {
     System.Environment.Exit( System.Environment.ExitCode );
   } // end method GUIThreadsForm_FormClosing

   // suspend or resume the corresponding thread
   private void threadCheckBox_CheckedChanged( object sender, 
      EventArgs e )
   {
      if ( sender == thread1CheckBox )
         letter1.Toggle();
      else if ( sender == thread2CheckBox )
         letter2.Toggle();
      else if ( sender == thread3CheckBox )
         letter3.Toggle();
   } // end method threadCheckBox_CheckedChanged
} // end class GUIThreadsForm

/**************************************************************************
 * (C) Copyright 1992-2006 by Deitel & Associates, Inc. and               *
 * Pearson Education, Inc. All Rights Reserved.                           *
 *                                                                        *
 * DISCLAIMER: The authors and publisher of this book have used their     *
 * best efforts in preparing the book. These efforts include the          *
 * development, research, and testing of the theories and programs        *
 * to determine their effectiveness. The authors and publisher make       *
 * no warranty of any kind, expressed or implied, with regard to these    *
 * programs or to the documentation contained in these books. The authors *
 * and publisher shall not be liable in any event for incidental or       *
 * consequential damages in connection with, or arising out of, the       *
 * furnishing, performance, or use of these programs.                     *
 *************************************************************************/