// Fig. 17.21: DrawShapes.cs
// Drawing various shapes on a Form.
using System;
using System.Drawing;
using System.Drawing.Drawing2D;
using System.Windows.Forms;

// draws shapes with different brushes
public partial class DrawShapesForm : Form
{
   // default constructor
   public DrawShapesForm()
   {
      InitializeComponent();
   } // end constructor

   // draw various shapes on Form
   private void DrawShapesForm_Paint( object sender, PaintEventArgs e )
   {
      // references to object we will use
      Graphics graphicsObject = e.Graphics;

      // ellipse rectangle and gradient brush
      Rectangle drawArea1 = new Rectangle( 5, 35, 30, 100 );
      LinearGradientBrush linearBrush =
         new LinearGradientBrush( drawArea1, Color.Blue,
            Color.Yellow, LinearGradientMode.ForwardDiagonal );

      // draw ellipse filled with a blue-yellow gradient
      graphicsObject.FillEllipse( linearBrush, 5, 30, 65, 100 );

      // pen and location for red outline rectangle
      Pen thickRedPen = new Pen( Color.Red, 10 );
      Rectangle drawArea2 = new Rectangle( 80, 30, 65, 100 );

      // draw thick rectangle outline in red
      graphicsObject.DrawRectangle( thickRedPen, drawArea2 );

      // bitmap texture
      Bitmap textureBitmap = new Bitmap( 10, 10 );

      // get bitmap graphics
      Graphics graphicsObject2 =
         Graphics.FromImage( textureBitmap );

      // brush and pen used throughout program
      SolidBrush solidColorBrush =
         new SolidBrush( Color.Red );
      Pen coloredPen = new Pen( solidColorBrush );

      // fill textureBitmap with yellow
      solidColorBrush.Color = Color.Yellow;
      graphicsObject2.FillRectangle( solidColorBrush, 0, 0, 10, 10 );

      // draw small black rectangle in textureBitmap
      coloredPen.Color = Color.Black;
      graphicsObject2.DrawRectangle( coloredPen, 1, 1, 6, 6 );

      // draw small blue rectangle in textureBitmap
      solidColorBrush.Color = Color.Blue;
      graphicsObject2.FillRectangle( solidColorBrush, 1, 1, 3, 3 );

      // draw small red square in textureBitmap
      solidColorBrush.Color = Color.Red;
      graphicsObject2.FillRectangle( solidColorBrush, 4, 4, 3, 3 );

      // create textured brush and 
      // display textured rectangle
      TextureBrush texturedBrush =
         new TextureBrush( textureBitmap );
      graphicsObject.FillRectangle( texturedBrush, 155, 30, 75, 100 );

      // draw pie-shaped arc in white
      coloredPen.Color = Color.White;
      coloredPen.Width = 6;
      graphicsObject.DrawPie( coloredPen, 240, 30, 75, 100, 0, 270 );

      // draw lines in green and yellow
      coloredPen.Color = Color.Green;
      coloredPen.Width = 5;
      graphicsObject.DrawLine( coloredPen, 395, 30, 320, 150 );

      // draw a rounded, dashed yellow line
      coloredPen.Color = Color.Yellow;
      coloredPen.DashCap = DashCap.Round;
      coloredPen.DashStyle = DashStyle.Dash;
      graphicsObject.DrawLine( coloredPen, 320, 30, 395, 150 );
   } // end method DrawShapesForm_Paint
} // end class DrawShapesForm


/**************************************************************************
 * (C) Copyright 1992-2006 by Deitel & Associates, Inc. and               *
 * Pearson Education, Inc. All Rights Reserved.                           *
 *                                                                        *
 * DISCLAIMER: The authors and publisher of this book have used their     *
 * best efforts in preparing the book. These efforts include the          *
 * development, research, and testing of the theories and programs        *
 * to determine their effectiveness. The authors and publisher make       *
 * no warranty of any kind, expressed or implied, with regard to these    *
 * programs or to the documentation contained in these books. The authors *
 * and publisher shall not be liable in any event for incidental or       *
 * consequential damages in connection with, or arising out of, the       *
 * furnishing, performance, or use of these programs.                     *
 *************************************************************************/