// Fig. 17.22: DrawStarsForm.cs
// Using paths to draw stars on the form.
using System;
using System.Drawing;
using System.Drawing.Drawing2D;
using System.Windows.Forms;

// draws randomly colored stars
public partial class DrawStarsForm : Form
{
   // default constructor
   public DrawStarsForm()
   {
      InitializeComponent();
   } // end constructor

   // create path and draw stars along it
   private void DrawStarsForm_Paint(object sender, PaintEventArgs e)
   {
      Graphics graphicsObject = e.Graphics;
      Random random = new Random();
      SolidBrush brush = 
         new SolidBrush( Color.DarkMagenta );

      // x and y points of the path
      int[] xPoints = 
         { 55, 67, 109, 73, 83, 55, 27, 37, 1, 43 };
      int[] yPoints = 
         { 0, 36, 36, 54, 96, 72, 96, 54, 36, 36 };

      // create graphics path for star;
      GraphicsPath star = new GraphicsPath();

      // create star from series of points
      for ( int i = 0; i <= 8; i += 2 )
         star.AddLine( xPoints[ i ], yPoints[ i ],
            xPoints[ i + 1 ], yPoints[ i + 1 ] );

      // close the shape
      star.CloseFigure();

      // translate the origin to (150, 150)
      graphicsObject.TranslateTransform( 150, 150 );

      // rotate the origin and draw stars in random colors
      for ( int i = 1; i <= 18; i++ )
      {
         graphicsObject.RotateTransform( 20 );

         brush.Color = Color.FromArgb( 
            random.Next( 200, 255 ), random.Next( 255 ), 
            random.Next( 255 ), random.Next( 255 ) );

         graphicsObject.FillPath( brush, star );
      } // end for
   } // end method DrawStarsForm_Paint
} // end class DrawStarsForm

