// Fig. 17.24: LogoAnimator.cs
// Program that animates a series of images.
using System;
using System.Drawing;
using System.Windows.Forms;

// animates a series of 30 images
public partial class LogoAnimator : Form
{
   private Image[] images = new Image[ 30 ];
   private int count = -1;

   // LogoAnimator constructor
   public LogoAnimator()
   {
      InitializeComponent();

      for ( int i = 0; i < 30; i++ )
         images[ i ] = Image.FromFile( @"images\deitel" + i + ".gif" );

      logoPictureBox.Image = images[ 0 ]; // display first image

      // set PictureBox to be the same size as Image
      logoPictureBox.Size = logoPictureBox.Image.Size;
   } // end LogoAnimator constructor

   // event handler for timer's Tick event
   private void timer_Tick( object sender, EventArgs e )
   {
      count = ( count + 1 ) % 30; // increment counter
      logoPictureBox.Image = images[ count ]; // display next image
   } // end method timer_Tick
} // end class LogoAnimator


/**************************************************************************
 * (C) Copyright 1992-2006 by Deitel & Associates, Inc. and               *
 * Pearson Education, Inc. All Rights Reserved.                           *
 *                                                                        *
 * DISCLAIMER: The authors and publisher of this book have used their     *
 * best efforts in preparing the book. These efforts include the          *
 * development, research, and testing of the theories and programs        *
 * to determine their effectiveness. The authors and publisher make       *
 * no warranty of any kind, expressed or implied, with regard to these    *
 * programs or to the documentation contained in these books. The authors *
 * and publisher shall not be liable in any event for incidental or       *
 * consequential damages in connection with, or arising out of, the       *
 * furnishing, performance, or use of these programs.                     *
 *************************************************************************/