// Fig. 23.9: CityWeather.cs
// Class representing the weather information for one city.
using System;

namespace Weather
{
   [ Serializable ]
   public class CityWeather : IComparable
   {
      private string cityName;   
      private string description;
      private string temperature;

      public CityWeather( string city, string information,
          string degrees )
      {
         cityName = city;
         description = information;
         temperature = degrees;
      } // end constructor

      // read-only property that gets city's name
      public string CityName
      {
         get
         {
            return cityName;
         } // end get
      } // end property CityName

      // read-only property that gets city's weather description
      public string Description
      {
         get
         {
            return description;
         } // end get
      } // end property Description

      // read-only property that gets city's temperature
      public string Temperature
      {
         get
         {
            return temperature;
         } // end get
      } // end property Temperature

      // implementation of CompareTo method for alphabetizing
      public int CompareTo( object other )
      {
         return string.Compare(                            
            CityName, ( ( CityWeather ) other ).CityName );
      } // end method Compare

      // return string representation of this CityWeather object
      // (used to display the weather report on the server console)
      public override string ToString()
      {
         return cityName + " | " + temperature + " | " + description;
      } // end method ToString
   } // end class CityWeather
} // end namespace Weather

/**************************************************************************
 * (C) Copyright 1992-2006 by Deitel & Associates, Inc. and               *
 * Pearson Education, Inc. All Rights Reserved.                           *
 *                                                                        *
 * DISCLAIMER: The authors and publisher of this book have used their     *
 * best efforts in preparing the book. These efforts include the          *
 * development, research, and testing of the theories and programs        *
 * to determine their effectiveness. The authors and publisher make       *
 * no warranty of any kind, expressed or implied, with regard to these    *
 * programs or to the documentation contained in these books. The authors *
 * and publisher shall not be liable in any event for incidental or       *
 * consequential damages in connection with, or arising out of, the       *
 * furnishing, performance, or use of these programs.                     *
 *************************************************************************/