// Fig. 23.12: WeatherServer.cs
// Server application that uses .NET remoting to send
// weather report information to a client
using System;
using System.Runtime.Remoting;              
using System.Runtime.Remoting.Channels;     
using System.Runtime.Remoting.Channels.Http;
using Weather;                              

class WeatherServer
{
   static void Main( string[] args )
   {
      // establish HTTP channel                      
      HttpChannel channel = new HttpChannel( 50000 );
      ChannelServices.RegisterChannel( channel, false );    

      // register ReportInfo class                       
      RemotingConfiguration.RegisterWellKnownServiceType(
         typeof( ReportInfo ), "Report",                 
         WellKnownObjectMode.Singleton );                

      Console.WriteLine( "Press Enter to terminate server." );
      Console.ReadLine();
   } // end Main
} // end class WeatherServer

/**************************************************************************
 * (C) Copyright 1992-2006 by Deitel & Associates, Inc. and               *
 * Pearson Education, Inc. All Rights Reserved.                           *
 *                                                                        *
 * DISCLAIMER: The authors and publisher of this book have used their     *
 * best efforts in preparing the book. These efforts include the          *
 * development, research, and testing of the theories and programs        *
 * to determine their effectiveness. The authors and publisher make       *
 * no warranty of any kind, expressed or implied, with regard to these    *
 * programs or to the documentation contained in these books. The authors *
 * and publisher shall not be liable in any event for incidental or       *
 * consequential damages in connection with, or arising out of, the       *
 * furnishing, performance, or use of these programs.                     *
 *************************************************************************/